> For the complete documentation index, see [llms.txt](https://docs.navigaglobal.com/dashboard-plugin/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.navigaglobal.com/dashboard-plugin/api-and-gui/api/request.md).

# request

request is a proxy request to come around CORS issues.

Both callbacks and promises is supported so it is all about which approach you will want to take.

## How to use

#### (as callback)

```javascript
import { Plugin } from'@root'

Plugin.request('YOUR_ENDPOINT', data => console.log(data))
```

#### params (as callback)

```javascript
import { Plugin } from'@root'

Plugin.request('YOUR_ENDPOINT', {
    json: true
}, response => console.log(response))

// OR url in params
Plugin.request({
    url: 'YOUR_ENDPOINT',
    json: true
}, response => console.log(response))
```

When working with callbacks the request component will always try to parse the response as `json`.

If you want to handle the parsing by yourself and parse as something else than json `promise` is more suitable.

#### (as promise)

```javascript
import { Plugin } from'@root'

Plugin.request('YOUR_ENDPOINT')
    .then(response => response.text())
    .then(response => console.log(response))
```

{% hint style="info" %}
`GET` is the default request method.
{% endhint %}

#### Advanced examples

```javascript
Pluginrequest({
    url: 'YOUR_ENDPOINT',
    method: 'POST',
    formData {
        foo: 'bar'
    }
}, response => console.log(response))

// ============= //

Plugin.request({
    url: 'YOUR_ENDPOINT',
    headers: {
        "x-request-params": 'foobar'
    }
}, response => console.log(response))
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.navigaglobal.com/dashboard-plugin/api-and-gui/api/request.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
